/* ***** <NB> *****
 *
 * Огромнейшее человеческое спасибо:
 *      - Владимиру Паланту (http://xpoint.ru/forums/thread.xhtml?id=27554)
 *        и другим авторам "Adblock" (http://adblock.mozdev.org);
 *      - Авторам FlashBlock (http://flashblock.mozdev.org/).
 *
 * А так же:
 *      - Разработчикам Mozilla за предоставленную возможность
 *        порезвиться с js. Хотя лучше бы я просто поспал.
 *        (https://bugzilla.mozilla.org/show_bug.cgi?id=47475)
 *
 * Ну и
 *      "Всем тем, кто отдал свою душу Ветру..."
 *
 * ***** </NB> ***** */

/* ***** <Policy values> *****
 *
 * 1 -- Load all images
 * 2 -- Load images for this site only
 * 3 -- Load cached images only
 * 4 -- Don't load images
 *
 * ***** </Policy values> ***** */

//~ consts & vars

const ILO_CACHE_IMAGE_SERVICE = Components.classes["@mozilla.org/image/cache;1"]
        .getService(Components.interfaces.imgICache);
const ILO_CACHE_SERVICE = Components.classes["@mozilla.org/network/cache-service;1"]
        .getService(Components.interfaces.nsICacheService);

var iloCacheSession = ILO_CACHE_SERVICE.createSession("HTTP",
        Components.interfaces.nsICache.STORE_ANYWHERE, true);
iloCacheSession.doomEntriesIfExpired = false;

/************************************************************************
 *
 * Taaabzzz....
 * Maybe hack,.. Anyway, I love hacks... Sometimes... Not this hack.
 *
 ************************************************************************/

//~ Patch "browser.addTab" [tabbrowser.xml, <method name="addTab">]
//~ [was:] b.iloTabPolicy = (this.selectedBrowser.iloTabPolicy) ? \
        //~ this.selectedBrowser.iloTabPolicy : iloSettingsDefaultPolicy; \

//~ [was2:] b.iloTabPolicy = this.selectedBrowser.iloTabPolicy; \

var browser = getBrowser();

eval('gBrowser.addTab =' + browser.addTab.toString().replace(
'if (!blank)',
'   b.iloTabPolicy = iloSettingsDefaultPolicy ? \
                     iloSettingsDefaultPolicy : this.selectedBrowser.iloTabPolicy; \
    b.iloTabSelected = 2; \
    if (!blank)')
);

function iloTabSelect()
{
    var tab = browser.selectedBrowser;
    var doc = tab.contentDocument;
    if (tab.iloTabSelected)
    {
        if (tab.iloTabSelected == 1)
        {
            doc.iloUrlsBlock = doc.iloUrlsPass = "";
            
            //~ Refresh content in selected tab
            if (iloSettingsTabsRefresh)
                iloRefreshPageObjects(doc);
            
            tab.iloTabSelected = 3;
        }
        tab.iloTabSelected -= 1;
    }
    iloIndicatorSet(tab.iloTabPolicy);
}

/************************************************************************
 *
 * Page indicator (bottom-right-button): popup, click
 *
 ************************************************************************/

function iloCheckStatusClick(event)
{
    switch (event.button)
    {
        case 0:
            iloIndicatorClick();
            break;
        case 1:
            iloOpenSettingsWindow();
            break;
        case 2:
            iloIndicatorClick("-1");
            break;
    }
}

//~ [Something from utilityOverlay.js]
function iloCheckClick(node, event, button)
{
    if (button)
    {
        if (event.button == 1)
            iloOpenSettingsWindow();
        else if (event.button == 2)
            iloIndicatorClick("-1");
        return;
    }
    
    event.preventBubble();
    
    if (event.button == 1 && event.target.getAttribute("value"))
    {
        eval(node.getAttribute("oncommand"));
        closeMenus(event.target);
    }
}

function closeMenus(node)
{
    if ("tagName" in node)
    {
        if (node.namespaceURI == "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"
                    && (node.tagName == "menupopup" || node.tagName == "popup"))
            node.hidePopup();
        
        closeMenus(node.parentNode);
    }
}

function iloOpenSettingsWindow()
{
    var mediator =
        Components.classes['@mozilla.org/appshell/window-mediator;1'].
        getService(Components.interfaces.nsIWindowMediator);
    var settingsWindow = mediator.getMostRecentWindow("imglikeoperaSettingsWindow");
    
    if (settingsWindow)
        settingsWindow.focus();
    else
        window.open('chrome://imglikeopera/content/options.xul','','chrome,centerscreen,resizable');
}

function iloIndicatorClick(policy)
{
    if (policy == "settings")
        return iloOpenSettingsWindow();
    
    var tab = browser.selectedBrowser;
    var doc = tab.contentDocument;
    
    if (policy == "css")
    {
        policy = iloSettingsCssLoad ? false : true;
        ILO_PREF_BRANCH.setBoolPref("css.load", policy);
        ILO_OBSERV_SERVICE.notifyObservers(iloObserver, "ilo-Load-Settings", false);
        iloRefreshStyles(doc);
        return;
    }
    
    if (!policy)
    {
        //~ left-mouse-click
        var policy = tab.iloTabPolicy - 1;
        if (policy == 0) policy = 4;
    }
    else if (policy == "-1")
    {
        //~ right-mouse-click
        policy = tab.iloTabPolicy + 1;
        if (policy == 5) policy = 1;
    }
    
    policy -= 0; //~ Numbers vs. Strings
    
    if (policy != tab.iloTabPolicy)
    {
        tab.iloTabPolicy = doc.iloDocPolicy = policy;
        doc.iloUrlsBlock = doc.iloUrlsPass = "";
        
        iloIndicatorSet(policy);
        
        if (policy != 4)
            iloRefreshPageObjects(doc);
    }
    
}

function iloIndicatorPopup()
{
    var indicatorPopupItems = document.getElementById("ilo-menupopup").childNodes;
    indicatorPopupItems[5].setAttribute("checked", iloSettingsCssLoad);
    for (var k = 4; --k > -1;)
        indicatorPopupItems[k].setAttribute("checked", false);
    indicatorPopupItems[ 4 - browser.selectedBrowser.iloTabPolicy ].setAttribute("checked", true);
}

function iloIndicatorSet(policy)
{
    var butt = document.getElementById("ilo-button");
    
    butt.setAttribute("value", "policy" + policy);
    
    if (butt.getAttribute("label"))
        butt.setAttribute("label", "img: " + ILO_BUNDLE.getString("buttonPolicy" + policy));
}

/************************************************************************
 *
 * 1) contentAreaContextMenu --> popupshowing --> ilo-context-menu-load-image
 * 2) ctrl + rigthMouseClick
 *
 ************************************************************************/

function iloLoadImg(obj)
{
    obj = obj || gContextMenu.target;
    var objsrc = obj.getAttribute("ilo-full-src"); //~ need for inputs with type="image"
    
    var tab = browser.selectedBrowser;
    var doc = tab.contentDocument;
    
    var re = new RegExp( objsrc.replace(/(\.|\||\+|\?|\$|\(|\)|\[|\])/g,"\\\$1") + " " );
    doc.iloUrlsBlock = doc.iloUrlsBlock.replace(objsrc + " ", "");
    
    if (!re.test(doc.iloUrlsPass))
        doc.iloUrlsPass += objsrc + " ";
    
    //~ if policy == "Don't load images" ==> turn it to "Load from cache"
    if (tab.iloTabPolicy == 4)
    {
        tab.iloTabPolicy = doc.iloDocPolicy = 3;
        iloIndicatorSet(3);
    }
    
    if (!obj.getAttribute("ilo-ph-fix"))
    {
        try
        {
            ILO_CACHE_IMAGE_SERVICE.clearCache(false);
            var cacheEntryDescriptor = iloCacheSession.openCacheEntry(objsrc,
                                        Components.interfaces.nsICacheEntryDescriptor,
                                        false);
            if (cacheEntryDescriptor)
            {
                cacheEntryDescriptor.doom();
                cacheEntryDescriptor.close();
            }
        }
        catch(ex){}
    }
    
    iloRefreshPageObjects(doc, objsrc);
}


/************************************************************************
 *
 * Refresh images|styles in document
 *
 ************************************************************************/

function iloGetAllDocs(frameset)
{
    var docsArray = [frameset.document];
    
    for (var i = frameset.frames.length; --i > -1;)
        docsArray = docsArray.concat( iloGetAllDocs(frameset.frames[i]) );
    
    return docsArray;
}

function iloRefreshPageObjects(doc, objsrc)
{
    //~ var t0 = new Date().getTime();
    
    if (doc != window._content.document) return; //~ really need this "if"?
    
    var docs = iloGetAllDocs(window._content);
    for (var i = docs.length; --i > -1;)
    {
        iloRefreshObjectsInFrame(docs[i], objsrc);
        iloRefreshStyles(docs[i]);
    }
    
    //~ var t1 = new Date().getTime();
    //~ idump( "PageRefreshTime = " + ((t1 - t0) / 1000) + " sec. (docs.length="+docs.length+")" );
}

function getXPathVal(cType)
{
    return cType == "application/xhtml+xml" ?
                    ["//html:", function() {return "http://www.w3.org/1999/xhtml"}] :
                    ["//", null];
}

function iloRefreshObjectsInFrame(doc, objsrc)
{
    //~ _xpath[0] -- xpath; _xpath[1] -- xresolver
    
    var elms, obj, i=0, xpath, _xpath = getXPathVal(doc.contentType);
    
    xpath = _xpath[0] + (objsrc ? "*[@ilo-full-src='" + objsrc + "']" : "*[@ilo-ph-fix]");
    
    elms = doc.evaluate(xpath, doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    
    for (; (obj = elms.snapshotItem(i)); i++)
    {
        obj.iloFixP = null;
        obj.setAttribute("src", obj.getAttribute("src"));
    }
    
    if (!objsrc) return;
    
    //~ we need also refreshing other images for apply styles...
    //~ ugly, ugly, ugly!
    
    xpath = _xpath[0] + "*[@ilo-full-src!='" + objsrc + "']";
    
    elms = doc.evaluate(xpath, doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    
    for (i=0; (obj = elms.snapshotItem(i)); i++)
        obj.setAttribute("src", obj.getAttribute("src"));
}

function iloRefreshCssRules(sheet)
{
    var node = sheet.cssRules;
    for (var i = node.length; --i > -1;)
    {
        if (node[i].styleSheet)
            iloRefreshCssRules(node[i].styleSheet); //~ recursion
        else if (/background.*url/.test(node[i].cssText))
            node[i].style.backgroundImage = node[i].style.backgroundImage;
    }
}


function iloRefreshStyles(doc)
{
    if (!iloSettingsCssLoad) return;
    
    /**********************
     * inline styles
     *********************/
    
    var elms, obj=null, i=0, _xpath = getXPathVal(doc.contentType);
    
    _xpath[0] += "*[contains(@style,'url')]";
    
    elms = doc.evaluate(_xpath[0], doc, _xpath[1], XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
    
    for (; (obj = elms.snapshotItem(i)); i++)
        obj.style.backgroundImage = obj.style.backgroundImage;
    
    /**********************
     * <link>, <style>, <xml-stylesheet>
     *********************/
    
    var stSNode, ssMedia;
    var stS = doc.styleSheets;
    var stSCount = stS.length;
    
    for (i = 0; i < stSCount; i++)
    {
        ssMedia = stS[i].media.mediaText;
        if ("" != ssMedia && !/screen|projection/.test(ssMedia))
            break;
        
        stSNode = stS[i].ownerNode;
        
        //~ stSNode.nodeName.toLowerCase() = "style"||"link"||"xml-stylesheet"
        //~ if "style"-node: test for inline @import rules, like @import url("http://example.com/test.css")
        if (stSNode.nodeName.toLowerCase() == "style" && !/@import/.test(stSNode.textContent))
            stSNode.textContent = stSNode.textContent; //~ ...more simple and fast then other method
        else
            iloRefreshCssRules(stS[i]);
    }
}


/************************************************************************
 *
 * Startup
 *
 ************************************************************************/

var iloSettingsDefaultPolicy, iloSettingsTabsRefresh, iloSettingsCssLoad;

var iloObserver = {
    observe: function (aSubject, aTopic, aState) 
    {
        if (aTopic == "ilo-Load-Settings")
        {
            iloSettingsDefaultPolicy = ILO_PREF_BRANCH.getIntPref("default.policy");
            iloSettingsTabsRefresh = ILO_PREF_BRANCH.getBoolPref("tabs.refresh");
            iloSettingsCssLoad = ILO_PREF_BRANCH.getBoolPref("css.load");
        }
    },
};
ILO_OBSERV_SERVICE.addObserver(iloObserver, "ilo-Load-Settings", false);
ILO_OBSERV_SERVICE.notifyObservers(iloObserver, "ilo-Load-Settings", false);

function iloInit()
{
    //~ 2DO: try/catch (?)
    
    window.removeEventListener("load", iloInit, true);
    
    /* (toolbar || statusbar) button */
    var toolbarButton = document.getElementById("ilo-button");
    var statusbarButton = document.getElementById("ilo-button-start");
    if (!toolbarButton)
    {
        statusbarButton.setAttribute("id","ilo-button");
    }
    else
    {
        toolbarButton.appendChild( statusbarButton.childNodes[0].cloneNode(true) );
        var iloPanel = document.getElementById("ilo-statusbarpanel");
        iloPanel.parentNode.removeChild(iloPanel);
    }
    
    ILO_BUNDLE = document.getElementById("imglikeopera-string-bundle");
    
    //~ Set native browser policy: "Load All Images".
    //~ FF 1.0:
    ILO_PREF_SERVICE.getBranch("").setIntPref("network.image.imageBehavior", 0);
    //~ FF 1.1:
    ILO_PREF_SERVICE.getBranch("").setIntPref("permissions.default.image", 1);
    
    //~ yet another hack... is there a better way?..
    var hiddenWnd = Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService)
                    .hiddenDOMWindow;
    
    var _oldWindowOpenDialog = window.openDialog;
    //~ [a..n] -- max(?) [bookmarks.js BookmarksUtils::addLivemark (line ~1589)]
    window.openDialog = function() {
        try {
            hiddenWnd.iloOpenerPolicy = browser.selectedBrowser.iloTabPolicy;
        } catch(e){}
        
        var args = [];
        for (var i = 0; i < arguments.length; i++)
            args.push('arguments['+i+']');
        
        return eval('_oldWindowOpenDialog('+args.join(', ')+')');
    };
    
    var defPolicy;
    //~ hiddenWnd.iloOpenerPolicy not exist when program startup (first window).
    if (!iloSettingsDefaultPolicy)
        defPolicy = hiddenWnd.iloOpenerPolicy ? hiddenWnd.iloOpenerPolicy : 3;
    else
        defPolicy = iloSettingsDefaultPolicy;
    
    //~ Tabs switching.
    browser.addEventListener("select", iloTabSelect, false);
    
    //~ Current tab policy
    browser.selectedBrowser.iloTabPolicy = defPolicy;
    browser.selectedBrowser.iloTabSelected = 2;
    
    //~ Page-indicator.
    iloIndicatorSet(defPolicy);
    
    //~ Context Menu: + "Load Image".
    //~ document.getElementById("context-viewimage").hidden = true;
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing",
        function() {
            document.getElementById("ilo-context-menu-load-image").hidden =
                (gContextMenu.target instanceof Components.interfaces.nsIImageLoadingContent &&
                 gContextMenu.target.getAttribute("ilo-full-src")) ? false : true;
        },
    false);
    
    window.addEventListener("click",
        function(e) {
            if (e.ctrlKey &&
                e.target instanceof Components.interfaces.nsIImageLoadingContent &&
                e.target.getAttribute("ilo-full-src"))
            {
                e.preventDefault();
                iloLoadImg(e.target);
            }
        },
    false);
    
    eval('nsContextMenu.prototype.setTarget = ' +
          nsContextMenu.prototype.setTarget.toString()
              .replace(/this\.target\.currentURI(\.spec)?/g, 'this.target.src'));
    
    iloCheckBonusUserCss();
}

function iloUnload() {
    ILO_OBSERV_SERVICE.removeObserver(iloObserver,"ilo-Load-Settings");
}

window.addEventListener("load", iloInit, false);
window.addEventListener("unload", iloUnload, false);